import gobject,gnomevfs
import rb,rhythmdb

class SourceTest(rb.Plugin):
	def activate(self, shell):
		print "activating source test"
		self.db = shell.get_property("db")
		self.entry_type = self.db.entry_register_type("SourceTestEntryType")
		self.entry_type.can_sync_metadata = True
		self.entry_type.sync_metadata = None
		ie = self.db.entry_type_get_by_name("import-error")
		gps = gobject.new (SourceTestSource, entry_type = self.entry_type, shell = shell, name="Mr Experiment", import_error = ie)
		shell.register_entry_type_for_source(gps, self.entry_type)
		shell.append_source(gps, None)
		gobject.idle_add(gps.activate)

class SourceTestSource(rb.BrowserSource):
	__gproperties__ = {
		'import_error': (rhythmdb.EntryType, 'import_error', 'import_error', gobject.PARAM_WRITABLE|gobject.PARAM_CONSTRUCT_ONLY)
	}

	def __init__(self):
		rb.BrowserSource.__init__(self, name = _("SourceTestSource"))

	def do_set_property(self, property, value):
		if property.name == "import-error":
			self.import_error = value
		else:
			raise AttributeError, 'unknown property %s' % property.name

	def activate(self):
		self.testfile = gnomevfs.URI("/proc/version")
		print "adding testfile %s"%self.testfile
		shell = self.get_property("shell")
		self.__db = shell.get_property('db')
		self.__db.connect("entry_added",self.entry_added)
		self.__db.add_uri_with_type(self.testfile.path,self.get_property("entry_type"))
		rb.BrowserSource.do_impl_activate (self)

	def entry_added(self,tree,entry):
		if entry.get_entry_type() != self.get_property("entry_type"):
			if entry.get_entry_type() == self.import_error:
				uri = gnomevfs.URI(entry.get_playback_uri())
				print "failed to add entry %s"%uri
				if uri.path == self.testfile.path:
					print "it's the testfile!"
			return

gobject.type_register(SourceTestSource)

